## udev 124

=== Makefile ===
#
# Copyright (C) 2003-2004 Greg Kroah-Hartman <greg@kroah.com>
# Copyright (C) 2004-2006 Kay Sievers <kay.sievers@vrfy.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

VERSION = 124

# set this to make use of syslog
USE_LOG = true

# compile-in development debug messages
# (export UDEV_LOG="debug" or set udev_log="debug" in udev.conf
#  to print the debug messages to syslog)
DEBUG = false

# compile with gcc's code coverage option
USE_GCOV = false

# include Security-Enhanced Linux support
USE_SELINUX = false

# set this to create statically linked binaries
USE_STATIC = false

# to build any of the extras programs pass:
#  make EXTRAS="extras/<extra1> extras/<extra2>"
EXTRAS =

# make the build silent
V =

PROGRAMS = \
	udevd				\
	udevadm				\
	test-udev

HEADERS = \
	udev.h				\
	udevd.h				\
	udev_rules.h			\
	logging.h			\
	udev_sysdeps.h			\
	udev_selinux.h			\
	list.h

UDEV_OBJS = \
	udev_device.o			\
	udev_config.o			\
	udev_node.o			\
	udev_db.o			\
	udev_sysfs.o			\
	udev_rules.o			\
	udev_rules_parse.o		\
	udev_utils.o			\
	udev_utils_string.o		\
	udev_utils_file.o		\
	udevmonitor.o			\
	udevinfo.o			\
	udevcontrol.o			\
	udevtrigger.o			\
	udevsettle.o			\
	udevtest.o			\
	udev_sysdeps.o
LIBUDEV = libudev.a

MAN_PAGES = \
	udev.7				\
	udevd.8				\
	udevadm.8

GEN_HEADERS = \
	udev_version.h

prefix ?=
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev
udevdir =	/dev
DESTDIR =

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}
PWD = $(shell pwd)

CROSS_COMPILE ?=
CC = $(CROSS_COMPILE)gcc
LD = $(CROSS_COMPILE)gcc
AR = $(CROSS_COMPILE)ar
RANLIB = $(CROSS_COMPILE)ranlib

CFLAGS		+= -g -Wall -pipe -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
WARNINGS	= -Wstrict-prototypes -Wsign-compare -Wshadow \
		  -Wchar-subscripts -Wmissing-declarations -Wnested-externs \
		  -Wpointer-arith -Wcast-align -Wsign-compare -Wmissing-prototypes
CFLAGS		+= $(WARNINGS)

LDFLAGS += -Wl,-warn-common,--as-needed

OPTFLAGS = -Os
CFLAGS += $(OPTFLAGS)

ifeq ($(strip $(USE_LOG)),true)
	CFLAGS += -DUSE_LOG
endif

# if DEBUG is enabled, then we do not strip
ifeq ($(strip $(DEBUG)),true)
	CFLAGS  += -DDEBUG
endif

ifeq ($(strip $(USE_GCOV)),true)
	CFLAGS += -fprofile-arcs -ftest-coverage
	LDFLAGS += -fprofile-arcs
endif

ifeq ($(strip $(USE_SELINUX)),true)
	UDEV_OBJS += udev_selinux.o
	LIB_OBJS += -lselinux -lsepol
	CFLAGS += -DUSE_SELINUX
endif

ifeq ($(strip $(USE_STATIC)),true)
	CFLAGS += -DUSE_STATIC
	LDFLAGS += -static
endif

ifeq ($(strip $(V)),)
	E = @echo
	Q = @
else
	E = @\#
	Q =
endif
export E Q

all: $(PROGRAMS) $(MAN_PAGES)
	$(Q) extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) CC="$(CC)" \
			CFLAGS="$(CFLAGS)" \
			LD="$(LD)" \
			LDFLAGS="$(LDFLAGS)" \
			AR="$(AR)" \
			RANLIB="$(RANLIB)" \
			LIB_OBJS="$(LIB_OBJS)" \
			LIBUDEV="$(PWD)/$(LIBUDEV)" \
			-C $$target $@ || exit 1; \
	done;
.PHONY: all
.DEFAULT: all

# clear implicit rules
.SUFFIXES:

# build the objects
%.o: %.c $(HEADERS) $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

# "Static Pattern Rule" to build all programs
$(PROGRAMS): %: $(HEADERS) $(GEN_HEADERS) $(LIBUDEV) %.o
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o -o $@ $(LIBUDEV) $(LIB_OBJS)

$(LIBUDEV): $(HEADERS) $(GEN_HEADERS) $(UDEV_OBJS)
	$(Q) rm -f $@
	$(E) "  AR      " $@
	$(Q) $(AR) cq $@ $(UDEV_OBJS)
	$(E) "  RANLIB  " $@
	$(Q) $(RANLIB) $@

udev_version.h:
	$(E) "  GENHDR  " $@
	$(Q) echo "/* Generated by make. */" > $@
	$(Q) echo \#define UDEV_VERSION		\"$(VERSION)\" >> $@
	$(Q) echo \#define UDEV_ROOT		\"$(udevdir)\" >> $@
	$(Q) echo \#define UDEV_CONFIG_FILE	\"$(configdir)/udev.conf\" >> $@
	$(Q) echo \#define UDEV_RULES_DIR	\"$(configdir)/rules.d\" >> $@

# man pages
%.8 %.7: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) - find . -type f -name '*.orig' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name '*.rej' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name '*~' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name '*.[oas]' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name "*.gcno" -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name "*.gcda" -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name "*.gcov" -print0 | xargs -0r rm -f
	$(Q) - rm -f udev_gcov.txt
	$(Q) - rm -f core $(PROGRAMS) $(GEN_HEADERS)
	$(Q) - rm -f udev-$(VERSION).tar.gz
	$(Q) - rm -f udev-$(VERSION).tar.bz2
	$(Q) - rm -f udev-git-HEAD.patch
	@ extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: clean

install-config:
	$(INSTALL) -d $(DESTDIR)$(configdir)/rules.d
	@ if [ ! -r $(DESTDIR)$(configdir)/udev.conf ]; then \
		$(INSTALL_DATA) etc/udev/udev.conf $(DESTDIR)$(configdir); \
	fi
	@ for i in etc/udev/rules.d/*.rules; do \
		if [ ! -r $(DESTDIR)$(configdir)/rules.d/$$(basename $$i) ]; then \
			$(INSTALL_DATA) $$i $(DESTDIR)$(configdir)/rules.d; \
		fi \
	done
	@ extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: install-config

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man7
	$(INSTALL_DATA) udev.7 $(DESTDIR)$(mandir)/man7/udev.7
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) udevd.8 $(DESTDIR)$(mandir)/man8/udevd.8
	$(INSTALL_DATA) udevadm.8 $(DESTDIR)$(mandir)/man8/udevadm.8
	@extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: install-man

uninstall-man:
	- rm -f $(DESTDIR)$(mandir)/man7/udev.7
	- rm -f $(DESTDIR)$(mandir)/man8/udevadm.8
	- rm -f $(DESTDIR)$(mandir)/man8/udevd.8
	@ extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: uninstall-man

install-bin:
	$(INSTALL) -d $(DESTDIR)$(sbindir)
	$(INSTALL_PROGRAM) udevd $(DESTDIR)$(sbindir)/udevd
	$(INSTALL_PROGRAM) udevadm $(DESTDIR)$(sbindir)/udevadm
	ln -f -s udevadm $(DESTDIR)$(sbindir)/udevsettle
	$(INSTALL) -d $(DESTDIR)$(usrbindir)
	ln -f -s $(sbindir)/udevadm $(DESTDIR)$(usrbindir)/udevinfo
	@extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
ifndef DESTDIR
	- killall udevd
	- rm -rf $(udevdir)/.udev
	- $(sbindir)/udevd --daemon
endif
.PHONY: install-bin

uninstall-bin:
	- rm -f $(DESTDIR)$(sbindir)/udevd
	- rm -f $(DESTDIR)$(sbindir)/udevadm
	- rm -f $(DESTDIR)$(sbindir)/udevsettle
	- rm -f $(DESTDIR)$(usrbindir)/udevinfo
ifndef DESTDIR
	- killall udevd
	- rm -rf $(udevdir)/.udev
endif
	@extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: uninstall-bin

install: all install-bin install-config install-man
.PHONY: install

uninstall: uninstall-bin uninstall-man
.PHONY: uninstall

test tests: all
	@ cd test && ./udev-test.pl
.PHONY: test tests

buildtest:
	test/simple-build-check.sh
.PHONY: buildtest

ChangeLog:
	head -1 $@ | grep -q "to v$(shell echo $$(($(VERSION) - 1)))"
	@ mv $@ $@.tmp
	@ echo "Summary of changes from v$(shell echo $$(($(VERSION) - 1))) to v$(VERSION)" >> $@
	@ echo "============================================" >> $@
	@ echo >> $@
	@ git log --pretty=short $(shell echo $$(($(VERSION) - 1)))..HEAD | git shortlog  >> $@
	@ echo >> $@
	@ cat $@
	@ cat $@.tmp >> $@
	@ rm $@.tmp
	head -1 $@ | grep -q "to v$(VERSION)"
.PHONY: ChangeLog
.PRECIOUS: ChangeLog

release:
	$(Q) - rm -f udev-$(VERSION).tar.gz
	$(Q) - rm -f udev-$(VERSION).tar.bz2
	head -1 ChangeLog | grep -q "to v$(VERSION)"
	head -1 RELEASE-NOTES | grep -q "udev $(VERSION)"
	git commit -a -m "release $(VERSION)"
	cat .git/refs/heads/master > .git/refs/tags/$(VERSION)
	@ echo
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | gzip -9v > udev-$(VERSION).tar.gz
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | bzip2 -9v > udev-$(VERSION).tar.bz2
.PHONY: release

dist:
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | gzip -9v > udev-$(VERSION).tar.gz
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | bzip2 -9v > udev-$(VERSION).tar.bz2
.PHONY: dist

patch:
	git diff $(shell echo $$(($(VERSION) - 1))) HEAD > udev-git-HEAD.patch
.PHONY: patch

gcov-all:
	$(MAKE) clean all USE_GCOV=true
	@ echo
	@ echo "binaries built with gcov support."
	@ echo "run the tests and analyze with 'make udev_gcov.txt'"
.PHONY: gcov-all

# see docs/README-gcov_for_udev
udev_gcov.txt: $(wildcard *.gcda) $(wildcard *.gcno)
	for file in `find -maxdepth 1 -name "*.gcno"`; do \
		name=`basename $$file .gcno`; \
		echo "################" >> $@; \
		echo "$$name.c" >> $@; \
		echo "################" >> $@; \
		if [ -e "$$name.gcda" ]; then \
			gcov -l "$$name.c" >> $@ 2>&1; \
		else \
			echo "code for $$name.c was never executed" >> $@ 2>&1; \
		fi; \
		echo >> $@; \
	done; \
	echo "view $@ for the result"

=== extras/cdrom_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = cdrom_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
	$(INSTALL) -d $(DESTDIR)$(configdir)/rules.d
	$(INSTALL_DATA) 60-cdrom_id.rules $(DESTDIR)$(configdir)/rules.d/60-cdrom_id.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
	- rm $(DESTDIR)$(configdir)/rules.d/60-cdrom_id.rules
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/edd_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = edd_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
	$(INSTALL) -d $(DESTDIR)$(configdir)/rules.d/
	$(INSTALL_DATA) 61-persistent-storage-edd.rules $(DESTDIR)$(configdir)/rules.d/61-persistent-storage-edd.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
	- rm $(DESTDIR)$(configdir)/rules.d/61-persistent-storage-edd.rules
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/rule_generator/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2006 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_DATA) rule_generator.functions $(DESTDIR)$(libudevdir)/rule_generator.functions
	$(INSTALL_SCRIPT) write_cd_rules $(DESTDIR)$(libudevdir)/write_cd_rules
	$(INSTALL_SCRIPT) write_net_rules $(DESTDIR)$(libudevdir)/write_net_rules
	$(INSTALL) -d  $(DESTDIR)$(configdir)/rules.d
	$(INSTALL_DATA) 75-cd-aliases-generator.rules \
		$(DESTDIR)$(configdir)/rules.d/75-cd-aliases-generator.rules
	$(INSTALL_DATA) 75-persistent-net-generator.rules \
		$(DESTDIR)$(configdir)/rules.d/75-persistent-net-generator.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/rule_generator.functions
	- rm $(DESTDIR)$(libudevdir)/write_cd_rules
	- rm $(DESTDIR)$(libudevdir)/write_net_rules
	- rm $(DESTDIR)$(configdir)/rules.d/75-cd-aliases-generator.rules
	- rm $(DESTDIR)$(configdir)/rules.d/75-persistent-net-generator.rules
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: install-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

## udev 147~-6

=== debian/changelog ===
udev (147~-6) karmic; urgency=low

  * debian/udev.initramfs-hook:
    - Include the firmware helper.  LP: #381037.

 -- Scott James Remnant <scott@ubuntu.com>  Thu, 15 Oct 2009 20:47:20 +0100

udev (147~-5) karmic; urgency=low

  * debian/udev.initramfs-top:
    - Rename from udev.initramfs-bottom and move from local-premount to
      init-top
    - Add a pre-requisite on all_generic_ide so that gets a chance before
      we load IDE devices.
  * rules/rules.d/80-drivers.rules:
    - load the fbcon driver when a framebuffer is created.
      LP: #392039, #431812.

 -- Scott James Remnant <scott@ubuntu.com>  Wed, 23 Sep 2009 14:22:52 -0700

udev (147~-4) karmic; urgency=low

  * Update to GIT HEAD (still pre 147 release):
    - fix signal mask harder.  LP: #407428, #434852.

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 22 Sep 2009 22:45:39 +0100

udev (147~-3) karmic; urgency=low

  * Update to GIT HEAD (still pre 147 release):
    - includes fix from previous revision
    - rename interfaces to <iface>_rename if rename fails.  LP: #416782.
    - drop most NAME keys since 2.6.31 supplies them.
    - especially those with just "%k".  LP: #430654.
    - fixed SYMLINK option parsing.  LP: #430654.

  * Remove 40-alsa.rules now it's not shipped upstream.

 -- Scott James Remnant <scott@ubuntu.com>  Mon, 21 Sep 2009 16:02:32 -0700

udev (147~-2) karmic; urgency=low

  * rules/rules.d/60-persistent-storage.rules: Fix blkid invocation for
    CD-ROMs, thanks to Maxim Levitsky for tracking this down! Fix committed to
    GIT HEAD, and cherrypicked. (LP: #431055)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sun, 20 Sep 2009 19:47:17 +0200

udev (147~-1) karmic; urgency=low

  FFE LP: #427356.

  * Update to GIT HEAD (pre 147 release):
    - worker signal mask corrected.  LP: #407428.
    - database format change to avoid path length issues.  LP: #377121.
    - multiple devices may not claim the same /dev names, except with
      symlinks
    - NAME="%k" produces a warning
    - symlinks to udevadm no longer resolve to the original command
    - rules updates.  LP: #281335, LP: #407940, #420015, #426647.

  * Build-depend on gawk, since build fails with mawk.

  * Replace init scripts with Upstart jobs.
  * debian/control:
    - Add missing ${misc:Depends}
    - Bump build-dependency on debhelper for Upstart-aware dh_installinit

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 15 Sep 2009 03:22:11 +0100

udev (146-1) karmic; urgency=low

  * New upstream release:
    - udevadm trigger "--retry-failed" replaced by "--type=failed"
    - RUN "ignore_error" option replaced by "fail_event_on_error"
    - Added HP Presario 2100 keymap.  LP: #20223.
    - Added more keymap coverage for Compaq Evo models.  LP: #35382.
    - Added Fujitsu Amilo M keymap.  LP: #48547.
    - Added Compal Hel80i keymap.  LP: #198530.
    - Added Zepto ZNote keymap.  LP: #400252.
    - Added Everex Stepnote XT5000T keymap.  LP: #400921.
    - Added rules to switch mode of Huawei E1550 GSM modem.  LP: #401655.
    - Various other keymap and modem updates.

  [ Martin Pitt ]
  * debian/control: Add missing Breaks: casper (<< 1.174) to avoid breaking
    upgrades from jaunty in wubi installations. (LP: #400138)

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 25 Aug 2009 13:45:17 +0100

udev (145-1) karmic; urgency=low

  * New upstream release:
    - detach event from worker if killed.
    - make sure a worker finishes its event before exiting.  LP: #396957.
    - handle SIGCHLD before worker messages.
    - use qsort() to sort list rather than by hand (performance).
    - correct mangling of scsi_id return values

  * debian/rules: Update "prep" target to not wipe uncommitted files.
  * debian/libudev-dev.install: Install the restored libtool file
  * debian/libgudev-1.0-dev.install: Install the restored libtool file

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 14 Jul 2009 17:10:38 +0100

udev (143-8) karmic; urgency=low

  * Disable extras for the udeb, since the necessary dependencies aren't
    available.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 01 Jul 2009 10:24:17 +0100

udev (143-7) karmic; urgency=low

  * debian/rules: Add "prep" target to get a buildable source tree. This cares
    for autoconfiscation, and fixes gtk-docs' makefile snippet to get along
    with our separate build trees.
  * debian/rules: Call dh_install with --fail-missing, to avoid regressions
    like the recent dropping of the ConsoleKit helper.
  * debian/udev.install: Add missing ConsoleKit helper. This repairs device
    ACLs.
  * debian/udev.install: Add missing usr/share/doc/udev (README.keymap and
    "writing udev rules")
  * debian/udev.install: Install udev.pc. Not much here, but can't hurt, and
    other software might rely on it.
  * debian/libgudev-1.0-dev.install: Install gtk-doc documentation.
  * debian/libudev-dev.install: Install gtk-doc documentation.
  * debian/copyright: Fix formerly versionless reference to GPL.
  * debian/control: Put libudev-dev into section "libdevel".
  * debian/rules: Call dh_installdeb after dh_makeshlibs, so that the
    debhelper scripts from the latter actually get active. Fixes ldconfig
    calling.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 30 Jun 2009 19:09:38 +0200

udev (143-6) karmic; urgency=low

  * debian/libgudev-1.0-0.install, debian/libgudev-1.0-dev.install:
    - Files are actually installed into /usr/lib already
    - Fix wildcard pkgconfig inclusion
    - Fix wildcard /usr/include inclusion
    - Include static library
    - Drop libtool .la file since it's not generated

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 30 Jun 2009 10:09:42 +0100

udev (143-5) karmic; urgency=low

  * Add missing files.

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 30 Jun 2009 09:47:13 +0100

udev (143-4) karmic; urgency=low

  * debian/udev-udeb.install: Drop /etc/scsi_id.config here too

 -- Scott James Remnant <scott@ubuntu.com>  Mon, 29 Jun 2009 12:12:19 +0100



=== debian/control ===
Source: udev
Section: admin
Priority: important
Maintainer: Scott James Remnant <scott@ubuntu.com>
Standards-Version: 3.8.0.0
Build-Depends: debhelper (>= 7.3.15ubuntu2), pkg-config, libselinux1-dev (>= 1.28-1), libsepol1-dev, libglib2.0-dev (>= 2.12.0), libusb-dev (>= 1:0.1.12), libacl1-dev, usbutils (>= 0.82), pciutils, xsltproc, docbook-xsl, gtk-doc-tools, gperf, gawk
Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/udev/ubuntu

Package: udev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, module-init-tools (>= 3.2.1-0ubuntu3), initramfs-tools (>= 0.40ubuntu30), procps, adduser, util-linux (>> 2.15~rc2)
Conflicts: hotplug, ifrename, libdevmapper1.02 (<< 2:1.02.08-1ubuntu7), udev-extras (<= 20090618)
Replaces: hotplug, initramfs-tools (<< 0.040ubuntu1), ifrename, udev-extras (<= 20090618)
Suggests: watershed
Breaks: dmsetup (<= 2:1.02.27-4ubuntu5), lvm2 (<= 2.02.39-0ubuntu9), mdadm (<= 2.6.7.1-1ubuntu8), initramfs-tools (<< 0.92bubuntu30), casper (<< 1.174)
Description: rule-based device node and kernel event manager
 udev is a collection of tools and a daemon to manage events received from
 the kernel and deal with them in user-space.  Primarily this involves
 creating and removing device nodes in /dev when hardware is discovered or
 removed from the system.
 .
 Events are received via kernel netlink messaged and processed according to
 rules in /etc/udev/rules.d and /lib/udev/rules.d, altering the name of the
 device node, creating additional symlinks or calling other tools and programs
 including those to load kernel modules and initialise the device.

Package: udev-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rule-based device node and kernel event manager

Package: libudev0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: udev library
 libudev provides a set of functions for accessing the udev database
 and querying sysfs.

Package: libudev-dev
Priority: optional
Section: libdevel
Architecture: any
Depends: libudev0 (= ${Source-Version}), ${shlibs:Depends}, ${misc:Depends}
Description: udev library (development files)
 libudev provides a set of functions for accessing the udev database
 and querying sysfs.
 .
 This package provides a static library and C header files.

Package: libgudev-1.0-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GObject-based wrapper library for libudev
 This library makes it much simpler to use libudev from programs already using
 GObject. It also makes it possible to easily use libudev from other
 programming languages, such as Javascript, because of GObject introspection
 support.
 .
 This package contains the shared libraries.

Package: libgudev-1.0-dev
Section: libdevel
Architecture: any
Depends: libgudev-1.0-0 (= ${binary:Version}), libudev-dev, libglib2.0-dev, pkg-config, ${shlibs:Depends}, ${misc:Depends}
Description: GObject-based wrapper library for libudev -- development files
 This library makes it much simpler to use libudev from programs already using
 GObject. It also makes it possible to easily use libudev from other
 programming languages, such as Javascript, because of GObject introspection
 support.
 .
 This package contains the header and pkgconfig files needed for developing
 applications that use libgudev1.0.

## udev 147~-6.1

=== debian/changelog ===
udev (147~-6.1) karmic-proposed; urgency=low

  * udev/udev-node.c: Properly close directory handles to fix a major fd leak
    which caused hotplugging to fail entirely. (LP: #463347)
  * udev/udevd.c, handle_inotify(): Fix datatype for FIONREAD ioctl return
    type. It must be an int, not an ssize_t; the latter causes uninitialized
    values and tries to allocate a 15 digit number of bytes, unless the upper
    half of the variable just happens to be zeroed. (Upstream commit
    http://git.kernel.org/?p=linux/hotplug/udev.git;a=commit;h=4daa146b)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 02 Nov 2009 23:47:49 +0100

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the udev package.
# Copyright © 2009 Canonical Ltd.
# Author: Scott James Remnant <scott@ubuntu.com>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS

CFLAGS = -Wall -g -fstack-protector -fPIE
LDFLAGS = -Wl,-z,relro -Wl,-z,now -pie

# Disable optimisations if noopt found in $DEB_BUILD_OPTIONS
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
	LDFLAGS += -Wl,-O0
else
	CFLAGS += -Os
	LDFLAGS += -Wl,-O1
endif

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

VERSION = $(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/.*: //p')
UPSTREAM = $(shell echo $(VERSION) | sed -e 's/-[^-]*$$//')


# Configure the package
build-deb/config.status: configure
	[ -d build-deb ] || mkdir build-deb
	cd build-deb && ../configure \
		$(confflags) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		--prefix=/usr \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--libdir=/usr/lib \
		--with-rootlibdir=/lib \
		--libexecdir=/lib/udev \
		--mandir=\$${datadir}/man \
		--infodir=\$${infodir}/info \
		--with-selinux \
		--enable-static \
		--enable-gtk-doc

# Build the package
build-deb: build-deb/build-stamp
build-deb/build-stamp: build-deb/config.status
	dh_testdir

	$(MAKE) -C build-deb
	touch $@

# Install files into the deb
install-deb: DH_OPTIONS=-Nudev-udeb
install-deb: build-deb
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -v

	$(MAKE) -C build-deb DESTDIR="$(CURDIR)/debian/tmp" install

	# Documentation
	install -m 644 -o root -g root debian/README-etc-rules.d \
		debian/udev/etc/udev/rules.d/README
	install -m 644 -o root -g root debian/README-lib-rules.d \
		debian/udev/lib/udev/rules.d/README

	# Hook into initramfs-tools
	install -m 755 -o root -g root debian/udev.initramfs-hook \
		debian/udev/usr/share/initramfs-tools/hooks/udev
	install -m 755 -o root -g root debian/udev.initramfs-top \
		debian/udev/usr/share/initramfs-tools/scripts/init-top/udev
	install -m 755 -o root -g root debian/udev.initramfs-nfs \
		debian/udev/usr/share/initramfs-tools/scripts/nfs-top/udev
	install -m 755 -o root -g root debian/udev.initramfs-bottom \
		debian/udev/usr/share/initramfs-tools/scripts/init-bottom/udev


# Configure the udeb
build-udeb/config.status: configure
	[ -d build-udeb ] || mkdir build-udeb
	cd build-udeb && ../configure \
		$(confflags) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		--prefix=/usr \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--libdir=/usr/lib \
		--with-rootlibdir=/lib \
		--libexecdir=/lib/udev \
		--mandir=\$${datadir}/man \
		--infodir=\$${infodir}/info \
		--without-selinux \
		--enable-static \
		--disable-gtk-doc \
		--disable-extras

# Build the package
build-udeb: build-udeb/build-stamp
build-udeb/build-stamp: build-udeb/config.status
	dh_testdir

	$(MAKE) -C build-udeb
	touch $@


# Install files into the udeb
install-udeb: DH_OPTIONS=-pudev-udeb
install-udeb: build-udeb
	dh_testdir
	dh_testroot
	dh_clean -k -Xdebian/tmp
	rm -rf debian/tmp-udeb
	dh_installdirs

	$(MAKE) -C build-udeb DESTDIR="$(CURDIR)/debian/tmp-udeb" install

	# Startup script
	install -m 755 -o root -g root debian/udev.installer-startup \
		debian/udev-udeb/lib/debian-installer/start-udev

	# base-installer script
	install -m 755 -o root -g root debian/udev.base-installer \
		debian/udev-udeb/usr/lib/base-installer.d/05udev


build: build-deb build-udeb

binary: binary-indep binary-arch

# Build architecture-independent files here.
binary-indep:
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: DH_OPTIONS=-a
binary-arch: build install-deb install-udeb
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_installinit --no-start -- start 10 S .
	dh_installinit --name=udev-finish --no-start -- start 37 S .
	dh_installinit --upstart-only --name=udevtrigger --no-start
	dh_installinit --upstart-only --name=udevmonitor --no-start
	dh_install --sourcedir=debian/tmp -Nudev-udeb --fail-missing
	DH_OPTIONS= dh_install --sourcedir=debian/tmp-udeb -pudev-udeb
	dh_link
	dh_strip
	dh_compress
	dh_fixperms -X/lib/udev/devices/
	dh_makeshlibs
	dh_shlibdeps
	dh_installdeb
	DH_OPTIONS= dh_gencontrol -Nlibgudev-1.0-0 -Nlibgudev-1.0-dev
	DH_OPTIONS= dh_gencontrol -plibgudev-1.0-0 -plibgudev-1.0-dev -- "-v1:$(VERSION)"
	dh_md5sums
	dh_builddeb


# Clean up the mess we made
clean:
	dh_testdir

	rm -rf build-deb build-udeb debian/tmp-udeb
	dh_clean 


.PHONY: build-deb build-udeb build install-deb install-udeb \
	binary-indep binary-arch binary clean


# Madness
.PHONY: tarball
tarball: prep
	./configure --enable-gtk-doc
	make all dist
	cp udev-$(UPSTREAM).tar.gz ../udev_$(UPSTREAM).orig.tar.gz
	@echo "Created udev_$(UPSTREAM).orig.tar.gz in parent directory"

.PHONY: package
package: prep
	dpkg-buildpackage -S -i'(^|/)(.bzr|.gitignore|test)($$|/)'

# run this to get a buildable tree
.PHONY: prep
prep:
	gtkdocize --copy
	# fix gtk-doc breakage with separate build tree
	sed -i 's/srcdir/builddir/g' gtk-doc.make
	autoreconf -vi
	rm -r autom4te.cache

## udev 173

=== debian/changelog ===
udev (173-0ubuntu4) oneiric; urgency=low

  * Set a timeout of 61 seconds when calling udevadm control --exit, to
    ensure that udevd always reaches its *own* timeout first.  If udevadm
    times out before udevd, it exits non-zero, breaking the move of the /dev
    mount; and if we ignore the udevadm failure then udevd might still be
    running, which is the original issue that the patch for bug #624469
    was trying to address.  Raising the timeout doesn't make the boot any
    slower, it just makes sure we let udevd count the 60 seconds instead of
    udevadm.  LP: #818177.
  * debian/patches/race-condition-on-exit: Process events before signals
    in the worker thread, so we don't sit around waiting 60 seconds for an
    already-dead process.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Oct 2011 00:48:54 -0700

udev (173-0ubuntu3) oneiric; urgency=low

  * Include input_id in the initramfs to prevent errors when enumerating
    devices in early init (LP: #831516).

 -- Andy Whitcroft <apw@canonical.com>  Tue, 23 Aug 2011 06:58:23 +0200

udev (173-0ubuntu2) oneiric; urgency=low

  * Add debian/patches/move-input_id-to-default-rules.patch: Fix bluetooth
    mice and keyboards in the X server. Patch cherry-picked from upstream.
    (LP: #827489)

 -- Felix Geyer <debfx-pkg@fobos.de>  Tue, 16 Aug 2011 18:00:41 +0200

udev (173-0ubuntu1) oneiric; urgency=low

  [ Martin Pitt ]
  * New upstream bug fix release.
  * debian/rules: Configure with --enable-udev_acl, the default changed in
    this upstream version because of newer systemd versions.
  * debian/udev.examples: Drop scsi_id.config, this file has been obsolete for
    a long time.

  [ David Henningsson ]
  * To enable jack detection in PulseAudio, make jack detection input
    devices world-readable, just as being done for joysticks (LP: #826662).

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 15 Aug 2011 13:02:20 +0200

udev (172-0ubuntu5) oneiric; urgency=low

  * The kernel won't mount devtmpfs automatically when /init exists, which
    is always the case in the installer, so mount it manually (LP: #817443).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 28 Jul 2011 15:37:48 +0100

udev (172-0ubuntu4) oneiric; urgency=low

  * debian/udev.installer-startup: Create /dev/pts before mounting it
    (LP: #815962).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 25 Jul 2011 16:53:47 +0100

udev (172-0ubuntu3) oneiric; urgency=low

  * debian/udev-udeb.dirs, debian/udev.dirs, debian/udev.postinst: Get rid of
    the remaining /lib/udev/devices/ stuff:
    - shm: will be symlinked to /run/shm/ by mountall, and avoid having a
      non-world-writable shm (which breaks e. g. ecryptfs)
    - net: created by devtmpfs already
    - pts: mounted as devpts by mountall
  * Drop debian/udev.init. It has a ton of deprecated stuff in it, and with
    upstream supporting systemd and us having upstart scripts there won't ever
    be a time when we go back to a sysvinit script.
  * debian/udev.installer-startup:
    - Drop copying of /lib/udev/devices/. udevd already does this, and it's
      obsolete with devtmpfs anyway.
    - Drop unconditional mounting of a tmpfs on /dev and mknod'ing stuff. We
      already have a devtmpfs there. Only mount devtmpfs if /dev/null doesn't
      exist already.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 14 Jul 2011 09:22:40 +0200

udev (172-0ubuntu2) oneiric; urgency=low

  * extras/cdrom_id/60-cdrom_id.rules: Revert "hd*" hack for powerpc; this
    already is, or should be fixed in the powerpc kernel configuration to use
    the SCSI interface. (Confirmed by Luke).
  * Move rules/rules.d/78-graphics-card.rules to
    debian/local/78-graphics-card.rules and install it in debian/udev.install
    instead of patching Makefile.am
  * Move inline change in rules/rules.d/80-drivers.rules to
    debian/patches/load-fbcon.patch.
  * Move extras/rule_generator/75-persistent-net-generator.rules inline change
    to debian/patches/ignore-eucalyptus-virtual-ifaces.patch.
  * Move libudev/libudev-monitor.c inline change to
    debian/patches/libudev-revert-SOCK_NONBLOCK.patch.
  * Revert autoconf files to upstream state, as we have no further direct
    patches to the upstream build system.
  * debian/source/format: Move to 3.0 (quilt) format.
  * Add debian/patches/use_run_tmpfs: Only use /run/ if it is a tmpfs. Stolen
    from Debian's udev 167-2, thanks Marco d'Itri! (LP: #807306)
  * debian/control: Update Maintainer: field to Ubuntu Developers.
  * debian/control: Bump Standards-Version to 3.9.2.
  * debian/source/options: Ignore *.types files in documentation.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 12 Jul 2011 08:36:12 +0200

udev (172-0ubuntu1) oneiric; urgency=low

  * New upstream release:
    - Now enables kenrel media polling if available. This goes together with
      the changes in udisks 1.0.3 to stop user-space polling if kernel polling
      is enabled.
    - Delete mobile-action-modeswitch, has been deprecated by usb-modeswitch
      for a long time now.
  * debian/rules: Fix build tree copying to cope with new upstream
    "build-aux/" directory.
  * debian/libudev0.symbols: Add new symbols for this release.
  * debian/control: Add gir1.2-gudev-1.0 dependency to libgudev-1.0-dev, as
    per current Debian GI policy.
  * debian/control: Wrap dependencies.
  * debian/control: Add versioned libudev0 dependency to udev. While udevd or
    the probers do not directly link to it (they have an internal copy), they
    still need to be in sync to work properly. (LP: #804577)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 11 Jul 2011 15:28:25 +0200

udev (171-0ubuntu4) oneiric; urgency=low

  [ Colin Watson ]
  * Update Vcs-Bzr field.

  [ Aurélien Couderc ]
  * Use "udevadm control --exit" in the initramfs instead of manually
    killing each udevd process (borrowed from Debian #624469).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 28 Jun 2011 17:50:21 +0100



=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,7 @@
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
 	confflags += --build=$(DEB_HOST_GNU_TYPE)
@@ -34,22 +35,28 @@
 VERSION = $(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/.*: //p')
 UPSTREAM = $(shell echo $(VERSION) | sed -e 's/-[^-]*$$//')
 
+DPKG_GENSYMBOLS_CHECK_LEVEL=4
+export DPKG_GENSYMBOLS_CHECK_LEVEL
 
 # Configure the package
 build-deb/config.status: configure
 	[ -d build-deb ] || mkdir build-deb
-	cd build-deb && ../configure \
+	# work around gtk-doc not being able to work in a separate build tree
+	# by copying the entire lot
+	cp -a `find -maxdepth 1 ! -name 'build*deb' ! -name 'debian' ! -name '.*'` build-deb
+	cd build-deb && ./configure \
 		$(confflags) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
 		--prefix=/usr \
 		--sysconfdir=/etc \
 		--sbindir=/sbin \
-		--libdir=/usr/lib \
-		--with-rootlibdir=/lib \
+		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
+		--with-rootlibdir=/lib/$(DEB_HOST_MULTIARCH) \
 		--libexecdir=/lib/udev \
 		--mandir=\$${datadir}/man \
 		--infodir=\$${infodir}/info \
 		--with-selinux \
 		--enable-static \
+		--enable-udev_acl \
 		--enable-gtk-doc
 
 # Build the package
@@ -65,10 +72,24 @@
 install-deb: build-deb
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
+	for file in libgudev-1.0-0.install; \
+	do \
+		sed -e"s,\$${DEB_HOST_MULTIARCH},${DEB_HOST_MULTIARCH},g" \
+			debian/$${file}.in > debian/$$file; \
+	done
 	dh_installdirs -v
 
 	$(MAKE) -C build-deb DESTDIR="$(CURDIR)/debian/tmp" install
+
+	# we install gudev into /usr/lib/, fix link
+	T=`readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgudev-1.0.so`; \
+	  rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgudev-1.0.so; \
+	  ln -s /usr/lib/$(DEB_HOST_MULTIARCH)/`basename $$T` debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgudev-1.0.so
+	# Fix up dependency_libs in libtool .la files
+	for file in `find debian/tmp/usr/lib/ -name \*.la`; do \
+		sed -i "/dependency_libs/ s/'.*'/''/" $$file ; \
+	done
 
 	# Documentation
 	install -m 644 -o root -g root debian/README-etc-rules.d \
@@ -102,8 +123,7 @@
 		--infodir=\$${infodir}/info \
 		--without-selinux \
 		--enable-static \
-		--disable-gtk-doc \
-		--disable-extras
+		--disable-gtk-doc
 
 # Build the package
 build-udeb: build-udeb/build-stamp
@@ -119,7 +139,7 @@
 install-udeb: build-udeb
 	dh_testdir
 	dh_testroot
-	dh_clean -k -Xdebian/tmp
+	dh_prep -Xdebian/tmp
 	rm -rf debian/tmp-udeb
 	dh_installdirs
 
@@ -154,14 +174,18 @@
 	dh_installinit --name=udev-finish --no-start -- start 37 S .
 	dh_installinit --upstart-only --name=udevtrigger --no-start
 	dh_installinit --upstart-only --name=udevmonitor --no-start
-	dh_install --sourcedir=debian/tmp -Nudev-udeb --fail-missing
-	DH_OPTIONS= dh_install --sourcedir=debian/tmp-udeb -pudev-udeb
+	dh_installinit --upstart-only --name=udev-fallback-graphics --no-start
+	dh_install --sourcedir=debian/tmp -Nudev-udeb -Nlibudev0-udeb --fail-missing
+	DH_OPTIONS= dh_install --sourcedir=debian/tmp-udeb -pudev-udeb -plibudev0-udeb
 	dh_link
 	dh_strip
 	dh_compress
 	dh_fixperms -X/lib/udev/devices/
-	dh_makeshlibs
+	DH_OPTIONS= dh_makeshlibs -plibudev0 -V 'libudev0 (>= 147)' --add-udeb=libudev0-udeb
+	DH_OPTIONS= dh_makeshlibs -plibgudev-1.0-0 -V 'libgudev-1.0-0 (>= 147)'
+	DH_OPTIONS= dh_makeshlibs -Nlibudev0 -Nlibgudev-1.0-0
 	dh_shlibdeps
+	dh_girepository
 	dh_installdeb
 	DH_OPTIONS= dh_gencontrol -Nlibgudev-1.0-0 -Nlibgudev-1.0-dev
 	DH_OPTIONS= dh_gencontrol -plibgudev-1.0-0 -plibgudev-1.0-dev -- "-v1:$(VERSION)"
@@ -189,16 +213,10 @@
 	cp udev-$(UPSTREAM).tar.gz ../udev_$(UPSTREAM).orig.tar.gz
 	@echo "Created udev_$(UPSTREAM).orig.tar.gz in parent directory"
 
-.PHONY: package
-package: prep
-	dpkg-buildpackage -S -i'(^|/)(.bzr|.gitignore|test)($$|/)'
-
 # run this to get a buildable tree
 .PHONY: prep
 prep:
 	gtkdocize --copy
-	# fix gtk-doc breakage with separate build tree
-	sed -i 's/srcdir/builddir/g' gtk-doc.make
 	autoreconf -vi
 	rm -r autom4te.cache
